using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace ArduinoProgrammer
{
    public partial class formArduinoProgrammer : Form
    {
        public formArduinoProgrammer()
        {
            InitializeComponent();
            update();   
            textBoxOutput.Clear();
            textBoxOutput.Text += "Not Working?" + Environment.NewLine;
            textBoxOutput.Text += "Don't forget to reset your Arduino immediately before programming!";
            textBoxOutput.Text += "  If the program looks like it's frozen, it's probably not.  If AVRDude ";
            textBoxOutput.Text += "is have trouble communicating with your board it can take a few minutes ";
            textBoxOutput.Text += "before it times out and stops trying.  To debug you can copy this text from ";
            textBoxOutput.Text += "the command box and make sure you can run it in your own windows console window." + Environment.NewLine + Environment.NewLine;
        }

        private void update()
        {
            textBoxArguments.Text = "";
            textBoxArguments.Text += "-F -v -pm168 -cstk500v1 -P\\\\.\\";
            textBoxArguments.Text += textBoxPort.Text;
            textBoxArguments.Text += " -b19200 -D -Uflash:w:\"";
            textBoxArguments.Text += textBoxHexFilePath.Text;
            textBoxArguments.Text += "\":i";
        }

        private void onClickButtomProgram(object sender, EventArgs e)
        {
            Process avrDudeProcess = new Process();
            avrDudeProcess.StartInfo.FileName = "cmd";
            avrDudeProcess.StartInfo.Arguments = "/K" + textBoxAVRDudePath.Text + " " + textBoxArguments.Text;

            try
            {
                avrDudeProcess.Start();
            }
            catch (Exception exc)
            {
                textBoxOutput.Text += "Error executing cmd: " + exc.Message + Environment.NewLine + Environment.NewLine;
            }
        }

        private void onTextChangedTextBoxPort(object sender, EventArgs e)
        {
            update();
        }

        private void onTextChangedTextBoxFilePath(object sender, EventArgs e)
        {
            update();
        }


        private void onTextChangedAVRDudePath(object sender, EventArgs e)
        {
            update();
        }

        private void onTextChangedArguments(object sender, EventArgs e)
        {
            textBoxCommand.Text = textBoxAVRDudePath.Text + " " + textBoxArguments.Text;
        }

        private void onClickButtonSelectFile(object sender, EventArgs e)
        {
            openFileDialogSelectHex.ShowDialog();
        }

        private void onFileSelected(object sender, CancelEventArgs e)
        {
            textBoxHexFilePath.Text = openFileDialogSelectHex.FileName;
        }

        private void onClickSelectAVRDudePath(object sender, EventArgs e)
        {
            openFileDialogAVRDUDE.ShowDialog();
        }

        private void onAVRDUDEFileSelected(object sender, CancelEventArgs e)
        {
            textBoxAVRDudePath.Text = openFileDialogAVRDUDE.FileName;
        }
    }
}